/*
  Beispiel 4 (C) : Definieren eines Drucker-Buffers und
                   Ausgabe einer Datei ueber Buffer an
                   die Drucker-Schnittstelle
                                                       */

#include <stdio.h>                  /* Standard I/O definieren */

extern mlbufst();                   /* Status des Drucker-Buffers */
extern mlbufset();                  /* Groesse des Buffers definieren */
extern mlbufwr();                   /* Ausgabe ueber Drucker-Buffer */

extern int err,mladr;               /* Fehlercode und Basisadresse Multi-LAB */

int groesse,                        /* Groesse des Buffers */
    status,                         /* Status des Druckerbuffers */
    ch;                             /* ASCII-Zeichen */
unsigned int k;                     /* Anzahl der freien Bytes */

anzahl()                            /* Ermitteln der Anzahl der freien Byte
                                    im Drucker-Buffer */
{
  do {
    mlbufst(&err,&status);          /* Lesen des Status des Drucker-Buffers */
    if (status != 0) {              /* Analyse des Status : */
      if (status < 128) k = status; /* Status gleich Anzahl */
      else k = 128;                 /* Status koennte weiter ausgewertet */
    }                               /* werden, siehe Kapitel 5.4 */
  } while (status == 0);            /* solange abfragen bis Status <> 0 */
}

main()
{
 FILE *fp, *fopen();                /* Text-Datei */

 mladr = 0x380;                     /* Basisadresse gleich 380H setzen */
 mlbufget(&err,&groesse);           /* Groesse des Drucker-Buffers
                                       auf der Multi-LAB Karte ermitteln */
 if (groesse == 0) {                /* Wenn die Groesse gleich Null ist, ist */
                                    /* der Drucker-Buffer noch nicht definiert : */
   groesse = 128;                   /* Drucker-Buffer definieren (32 K) : */
   mlbufset(err,groesse);           /* Es wird davon ausgegangen, dass */
 };                                 /* 32 K freies RAM zur Verfuegung stehen */
 anzahl;                            /* Ermitteln der Anzahl der freien Byte
                                       im Drucker-Buffer */
 fp = fopen("beisp4.c","r");        /* Einlesen des Namens der Datei und */
                                    /* Oeffnen der Datei */
 while ((ch = getc(fp)) != EOF) {   /* Datei bis zum Ende lesen */
   mlbufwr(&err,ch);                /* Zeichen aus Textdatei senden */
   if (k == 0)  anzahl;             /* Anzahl gleich 0 : Ermitteln */
                                    /* der Anzahl der freien Byte */
   else  k -= k;                    /* sonst : Anzahl dekrementieren */
 }
}


