'
' Beispiel 4 (Turbo-BASIC) : Definieren eines Drucker-Buffers und
'                            Ausgabe einer Datei ueber Buffer an
'                            die Drucker-Schnittstelle


$INCLUDE "MLABLIB.BAS"                           ' Einbinden der PASCAL-Bibliotheken
SUB anzahl                                       ' Ermitteln der Anzahl der freien Byte
                                                 ' im Drucker-Buffer
  status% = 0
  WHILE status% = 0
    call mlprnbufstat(ferr%,status%)             ' Lesen des Status des Drucker-Buffers
    if status% <> 0 then_                        ' Analyse des Status :
      if status% < 128 then_
        k% = status%_                            ' Status gleich Anzahl
      else_
        k% = 128                                 ' Status koennte weiter ausgewertet werden
                                                 ' siehe Kapitel 5.4
  WEND                                           ' solange abfragen bis Status <> 0

END SUB


SUB Demodrucker
SHARED mladr%,delaystat%
LOCAL groesse%                                   ' Groesse des Buffers
LOCAL status%                                    ' Status des Druckerbuffers
LOCAL ch$                                        ' ASCII-Zeichen
LOCAL k%                                         ' Anzahl der freien Bytes

  mladr% = &H380                                 ' Basisadresse gleich $380 setzen
  delaystat% = 2000                              ' Schleifenzaehler
  call mlgetbuf(ferr%,groesse%)                  ' Groesse des Drucker-Buffers
                                                 'auf der Multi-LAB Karte ermitteln
  if groesse% = 0 then                           ' Wenn die Groesse gleich Null ist,
    						 ' ist der Drucker-Buffer noch nicht definiert :
    groesse% = 128                               ' Drucker-Buffer definieren (32 K) :
    call mlsetbuf(ferr%,groesse%)                ' Es wird davon ausgegangen, dass
  end if                                         ' 32 K freies RAM zur Verfuegung stehen
  call anzahl                                    ' Ermitteln der Anzahl der freien Byte
                                                 ' im Drucker-Buffer
  OPEN "BEISP4TB.BAS" FOR INPUT AS #1              ' Oeffnen der Datei
  WHILE NOT EOF(1)                    		 ' Datei bis zum Ende lesen
    ch$ = INPUT$(1,1)                            ' Zeichen von der Textdatei einlesen
    call mlprnbufwrite(ferr%,ch$)                ' Zeichen aus Textdatei senden
      if k% = 0 then_                            ' Anzahl gleich 0 :
        call anzahl_                             ' Ermitteln der Anzahl der freien Byte
      else_
        k% = k% - 1                              ' sonst : Anzahl dekrementieren
  WEND

END SUB

call demodrucker

