unit mlab_lib;            (* Turbo-PASCAL 4.0, 5.0, 5.5 spezifisch *)

interface                 (* Turbo-PASCAL 4.0, 5.0, 5.5 spezifisch *)
  uses crt;               (* Turbo-PASCAL 4.0, 5.0, 5.5 spezifisch *)

{.pl72}

(* Letzte Bearbeitung : 19.06.1990  11:40 *)

(*

   P A S C A L  -  B I B L I O T H E K   fr die Makrobefehle

   der Multi-LAB Karte von SORCUS COMPUTER GmbH

   Version 2.0H        (nderungen vorbehalten)

   Bibliothek als Unit fr Turbo PASCAL Version 4.0, 5.0 und 5.5

   Durch Weglassen der Turbo-PASCAL 4.0, 5.0, 5.5 spezifischen Anweisungen
   (entspr. gekennnzeichnet) auch fr Turbo-PASCAL 3.0 verwendbar!

*)

type
    wert = array[1..64] of integer;

const
     mladr : integer = $380;
     delaystat : integer = 2000;
     err : byte = 0;

(* Interfacedefinition der Prozeduren und Funktionen *)

(* Turbo-PASCAL 4.0, 5.0, 5.5 spezifisch *)

procedure error(err : byte);
procedure mlwrite(datbyte : byte);
procedure mlread(var datbyte : byte);
procedure mlsync(var zustand : byte);
procedure mlreset(var err1 : byte);
procedure mlresblock(var err1 : byte);
procedure mlresunblock(var err1 : byte);
procedure mlram(var err1,ramgroesse : byte);
procedure mlvram(var err1 : byte;var efram,lfram : integer);
procedure mlsram(var err1 : byte;mode : byte;adr : integer);
procedure mlsetkonfig(var err1 : byte;config : byte);
procedure mlsetpoint(var err1 : byte;adr : integer);
procedure mlsetdat(var err1 : byte;datbyte : byte);
procedure mlsetdati(var err1 : byte;datbyte : byte);
procedure mloutport(var err1 : byte;portnr,datbyte : byte);
procedure mlstartpg(var err1 : byte);
procedure mlgetdat(var err1,datbyte : byte);
procedure mlgetdati(var err1,datbyte : byte);
procedure mlinport(var err1,datbyte : byte;portnr : byte);
procedure mlledon(var err1 : byte);
procedure mlledoff(var err1 : byte);
procedure mlledstat(var err1,zustand : byte);
procedure mlprnwrite(var err1 : byte;datbyte : char);
procedure mlprnstat(var err1,status : byte);
procedure mlprnbufstat(var err1 : byte;var status : byte);
procedure mlprnbufwrite(var err1 : byte;datbyte : char);
procedure mlgetbuf(var err1 : byte;var status : byte);
procedure mlsetbuf(var err1 : byte;datbyte : byte);
procedure mlprnbufstop(var err1 : byte);
procedure mlprnbufstart(var err1 : byte);
procedure mlserialinit(var err1 : byte;Usart,baud,dum1,dum2 : byte);
procedure mlserialwr(var err1 : byte;datbyte : byte);
procedure mlserialre(var err1,datbyte : byte);
procedure mlserialrst(var err1,status : byte);
procedure mlserialtst(var err1,status : byte);
procedure mlserflagon(var err1 : byte);
procedure mlserflagoff(var err1 : byte);
procedure mldiginall(var err1,ip07,ip815,ip1623 : byte);
procedure mldigin1(var err1,ip07 : byte);
procedure mldigin2(var err1,ip815 : byte);
procedure mldigin3(var err1,ip1623 : byte);
procedure mldigbitin(var err1,zustand : byte;bit : byte);
procedure mldigoutall0(var err1 : byte);
procedure mldigoutall1(var err1 : byte);
procedure mldigoutall(var err1 : byte;op07,op815,op1623 : byte);
procedure mldigout1(var err1 : byte;op07 : byte);
procedure mldigout2(var err1 : byte;op815 : byte);
procedure mldigout3(var err1 : byte;op1623 : byte);
procedure mldigbitout0(var err1 : byte;bit : byte);
procedure mldigbitout1(var err1 : byte;bit : byte);
procedure mlda12out(var err1 : byte;kanal : byte;datbyte : integer);
procedure mlda812out(var err1 : byte;kanal : byte;datbyte : integer);
procedure mldaabgleich(var err1 : byte);
procedure mldaignabgl(var err1 : byte);
procedure mlpenup(var err1 : byte);
procedure mlpendown(var err1 : byte);
procedure mlpenstat(var err1,zustand : byte);
procedure mlda122er(var err1 : byte;kanal : byte;datbyte : integer);
procedure mlposxy(var err1 : byte;X0,Y0 : integer);
procedure mllinxy(var err1 : byte;X1,Y1 : integer);
procedure mlsetkorflag(var err1 : byte;flag : byte);
procedure mlsetkorwert(var err1 : byte;flag : byte;wert : integer);
procedure mlda8out(var err1 : byte;kanal,datbyte : byte);
procedure mlad12in(var err1 : byte;var datbyte : integer;kanal : byte);
procedure mlad8in(var err1,datbyte : byte;kanal : byte);
procedure mlad122er(var err1 : byte;var datbyte : integer;var kanal : byte);
procedure mladsh12(var err1 : byte;var datbyte : wert;kanal : byte;anz : byte);
procedure mlad1220(var err1 : byte;var datbyte : integer;var kanal : byte);
procedure mlad12sa(var err1 : byte;var datbyte : integer;kanal,anz : byte);
procedure mlbartuhr(var err1 : byte;art : byte);
procedure mlsetbart(var err1 : byte;maske,wert : byte);
procedure mlsetuhrzeit(var err1 : byte;sec,min,std : byte);
procedure mlsetuhrdatum(var err1 : byte;tag,mon,jahr,wochentag,woche : byte);
procedure mlsetal(var err1 : byte;sec,min,std,tag : byte);
procedure mlsettim(var err1 : byte;sec,min,std : byte);
procedure mlgetuhrzeit(var err1,sec,min,std : byte);
procedure mlgetuhrdatum(var err1,tag,mon,jahr,wochentag,woche : byte);
procedure mlgetal(var err1,sec,min,std,tag : byte);
procedure mlgettim(var err1,sec,min,std : byte);
procedure mlgetbart(var err1,zustand : byte);
procedure mlsetsp(var err1 : byte;speicher,data : byte);
procedure mlgetsp(var err1,datbyte : byte;speicher : byte);

function mlreadstat : boolean;
function mlwritestat : boolean;

implementation            (* Turbo-PASCAL 4.0, 5.0, 5.5 spezifisch *)

(* Fehler-Check und Fehlermeldungen *)

procedure error(err : byte);
var
   ch : char;

(* Umwandeln einer Ziffer (0 bis 15) in ein ASCII-Zeichen ('0 bis 'F') *)

  function chn(bite : byte) : char;
  begin
    if bite > 9 then
      chn := chr(bite + $37)
    else
      chn := chr(bite + $30);
  end;

begin
  if err in [1..9] then
    begin
      writeln;
      writeln;
      writeln(chr(7),'*** Fehlermeldung von der Multi-LAB/1 Karte ***');
      writeln('*** Fehlercode : ',err,' ***');
      writeln;
    end
  else
    if err in [254,255] then
      begin
        writeln;
        writeln;
        if err = 254 then
          writeln(chr(7),'*** Fehler  : Multi-LAB/1 sendet kein Byte zurck   ***');
        if err = 255 then
          writeln(chr(7),'*** Fehler  : Multi-LAB/1 kann kein Byte empfangen  ***');
        writeln('*** Ursache : Falsche Basisadresse eingestellt oder ***');
        writeln('***           Delay zu klein                        ***');
        writeln;
      end;
  case err of
    0 : ;
    1 : writeln('Befehl ist ungltig');
    2 : writeln('Befehl ist unvollstndig bertragen');
    3 : writeln('Fehler bei der Ausfhrung des Befehls');
    4 : writeln('Befehl ist noch nicht implementiert');
    5 : writeln('Befehl kann nicht ausgefhrt werden, weil die Hardware nicht vorhanden ist');
    6 : begin
          writeln('Mit dem Befehl wurde eine Funktionseinheit angesprochen, die bereits fr eine');
          writeln('andere Funktion benutzt wird. Befehl wurde deshalb nicht ausgefhrt');
        end;
    7 : writeln('Die anfragende Schnittstelle ist nicht Host');
    8 : writeln('Es ist kein Zeichen an der seriellen Schnittstelle empfangen worden');
    9 : writeln('Die serielle Schnittstelle ist im Host-Mode');
    else
      begin
        writeln;
        writeln;
        writeln('***** Zurckgeliefertes Byte: ',
              chn(err div 16),chn(err mod 16),'H *****');
      end;
  end;
  if err > 0 then
    begin
      writeln;
      ch := 'N';
      write('Abbruch (J / N) [ N ] : ');
      readln(ch);
      if upcase(cH) = 'J' then
        begin
          clrscr;
          halt;
        end;
    end;
end;

(* Liegt ein Datenbyte von der Multi-LAB Karte vor ? *)

function mlreadstat : boolean;
var
   stat : boolean;   (* Status *)
   k,i : integer;

begin
  i := 0;
  stat := (port[mladr] and $80) = $80;     (* Lesen des Status Registers *)
  while (not stat) and (i < delaystat) do
    begin
      i := i + 1;
      stat := (port[mladr] and $80) = $80; (* Lesen des Status Registers *)
    end;
  mlreadstat := stat;
end;

(* Kann ein Datenbyte an die Multi-LAB Karte uebertragen werden ? *)

function mlwritestat : boolean;
var
   stat : boolean;         (* Status *)
   k,i : integer;

begin
  i := 0;
  stat := (port[mladr] and 1) <> 1;        (* Lesen des Status Registers *)
  while (not stat) and (i < delaystat) do
    begin
      i := i + 1;
      stat := (port[mladr] and 1) <> 1;  (* Lesen des Status Registers *)
    end;
  mlwritestat := stat;
end;

(* Schreiben eines Datenbytes an die Multi-LAB Karte *)

procedure mlwrite(datbyte : byte);
begin
  err := 0;
  if mlwritestat then                       (* Statusabfrage *)
    port[mladr+2] := datbyte                (* Senden eines Datenbytes *)
  else
    err := 255;
end;

(* Lesen eines Datenbytes von der Multi-LAB Karte *)

procedure mlread(var datbyte : byte);
begin
  err := 0;
  if mlreadstat then                        (* Statusabfrage *)
    datbyte := port[mladr+1]                (* Lesen eines Datenbytes *)
  else
    err := 254;
end;

(*************** Speicher und Konfigurationsbefehle **********************)

(* Synchronisierung der Multi-LAB Karte *)

procedure mlsync(var zustand : byte);
begin
  zustand := 0;                      (* Variable default = 0 *)
  mlwrite(0);                        (* Senden einer 0 *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlread(zustand);                   (* Lesen eines Datenbytes *)
end;

(* Reset der Multi-LAB Karte per Software *)

procedure mlreset(var err1 : byte);
begin
  port[mladr+3] := 0;                (* Datenbyte auf Resetadresse der *)
                                     (* Multi-LAB Karte schreiben *)
  err1 := 0;
end;

(* Hardware-Reset-Blockierung der Multi-LAB Karte einschalten *)

procedure mlresblock(var err1 : byte);
begin
  mlwrite($10);                      (* Befehlscode senden *)
  err1 := err;
end;

(* Hardware-Reset-Blockierung der Multi-LAB Karte ausschalten *)

procedure mlresunblock(var err1 : byte);
begin
  mlwrite($11);                      (* Befehlscode senden *)
  err1 := err;
end;

(* Groesse des vorhandenen RAM (Hardware) *)

procedure mlram(var err1,ramgroesse : byte);
var
   cmd : byte;

begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  ramgroesse := 0;                   (* Default = 0 setzen *)
  mlwrite($12);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlread(cmd);                       (* Datenbyte lesen *)
  if cmd = $12 then                  (* Datenbyte = Befehlscode -> *)
    mlread(ramgroesse)               (* Datenbyte lesen *)
  else
    err1 := cmd;                     (* sonst : Fehler *)
end;

(* Groesse des frei verfuegbaren RAM lesen (Software) *)

procedure mlvram(var err1 : byte;var efram,lfram : integer);
var
   dat1,dat2 : byte;

begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  efram := 0; lfram := 0;            (* Default = 0 setzen *)
  mlwrite($13);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlread(dat1);                      (* Datenbyte lesen *)
  if dat1 = $13 then                 (* Datenbyte = Befehlscode -> *)
    begin
      mlread(dat1);                  (* Datenbyte lesen *)
      if err <> 0 then exit;         (* Globale Fehlervariable <> 0 ? *)
      mlread(dat2);                  (* Datenbyte lesen *)
      if err <> 0 then exit;         (* Globale Fehlervariable <> 0 ? *)
      efram := dat2;
      efram := efram * 256 + dat1;
      mlread(dat1);                  (* Datenbyte lesen *)
      if err <> 0 then exit;         (* Globale Fehlervariable <> 0 ? *)
      mlread(dat2);                  (* Datenbyte lesen *)
      lfram := dat2;
      lfram := lfram * 256 + dat1;
    end
  else
    err1 := dat1;                    (* sonst : Fehler *)
end;

(* Setzen des verfuegbaren RAM (Software) *)

procedure mlsram(var err1 : byte;mode : byte;adr : integer);
begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  mlwrite($14);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(mode);                     (* Datenbyte senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(lo(adr));                  (* Datenbyte senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(hi(adr));                  (* Datenbyte senden *)
  err1 := err;
end;

(* Setzen der Konfiguration *)

procedure mlsetkonfig(var err1 : byte;config : byte);
begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  mlwrite($15);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(config);                   (* Konfiguration setzen *)
  err1 := err;
end;

(********************** Speicher und I/O-Befehle ***************************)

(* Setzen des Memorypointers *)

procedure mlsetpoint(var err1 : byte;adr : integer);
begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  mlwrite($20);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(lo(adr));                  (* Datenbyte senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(hi(adr));                  (* Datenbyte senden *)
  err1 := err;
end;

(* Byte an Memorypointer schreiben *)

procedure mlsetdat(var err1 : byte;datbyte : byte);
begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  mlwrite($21);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(datbyte);                  (* Datenbyte senden *)
  err1 := err;
end;

(* Byte an Memorypointer schreiben und Pointer inkrementieren *)

procedure mlsetdati(var err1 : byte;datbyte : byte);
begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  mlwrite($22);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(datbyte);                  (* Datenbyte senden *)
  err1 := err;
end;

(* Datenbyte an einen I/O-Port ausgeben *)

procedure mloutport(var err1 : byte;portnr,datbyte : byte);
begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  mlwrite($23);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(portnr);                   (* Portadresse senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(datbyte);                  (* Datenbyte senden *)
  err1 := err;
end;

(* Programm ab Memorypointer starten *)

procedure mlstartpg(var err1 : byte);
begin
  mlwrite($24);                      (* Befehlscode senden *)
  err1 := err;
end;

(* Byte von Memorypointer lesen *)

procedure mlgetdat(var err1,datbyte : byte);
var
   cmd : byte;

begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  datbyte := 0;                      (* Default = 0 setzen *)
  mlwrite($25);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlread(cmd);                       (* Datenbyte lesen *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  if cmd = $25 then                  (* Datenbyte = Befehlsbyte -> *)
    mlread(datbyte)                  (* Datenbyte lesen *)
  else
    err1 := cmd;                     (* sonst : Fehler *)
end;

(* Byte von Memorypointer lesen und Pointer inkrementieren *)

procedure mlgetdati(var err1,datbyte : byte);
var
   cmd : byte;

begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  datbyte := 0;                      (* Default = 0 setzen *)
  mlwrite($26);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlread(cmd);                       (* Datenbyte lesen *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  if cmd = $26 then                  (* Datenbyte = Befehlscode -> *)
    mlread(datbyte)                  (* Datenbyte lesen *)
  else
    err1 := cmd;                     (* sonst : Fehler *)
end;

(* Lesen eines Datenbytes von einer I/O-Adresse *)

procedure mlinport(var err1,datbyte : byte;portnr : byte);
var
   cmd : byte;

begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  datbyte := 0;                      (* Default = 0 setzen *)
  mlwrite($27);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(portnr);                   (* Portadresse senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlread(cmd);                       (* Datenbyte lesen *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  if cmd = $27 then                  (* Datenbyte = Befehlscode -> *)
    mlread(cmd)                      (* Datenbyte lesen *)
  else
    err1 := cmd;                     (* sonst : Fehler *)
end;

(****************************** LED ******************************************)

(* LED einschalten *)

procedure mlledon(var err1 : byte);
begin
  mlwrite($30);                      (* Befehlscode senden *)
  err1 := err;
end;

(* LED ausschalten *)

procedure mlledoff(var err1 : byte);
begin
  mlwrite($31);                      (* Befehlscode senden *)
  err1 := err;
end;

(* Status der LED *)

procedure mlledstat(var err1,zustand : byte);
var
   cmd : byte;

begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  zustand := 0;                      (* Default = 0 setzen *)
  mlwrite($33);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlread(cmd);                       (* Datenbyte lesen *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  if cmd = $33 then                  (* Datenbyte = Befehl *)
    mlread(zustand)                  (* Status lesen *)
  else
    err1 := cmd;                     (* sonst : Fehler *)
end;

(********************** Drucker-Schnittstelle ********************************)

(* Byte an Drucker ausgeben *)

procedure mlprnwrite(var err1 : byte;datbyte : char);
begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  mlwrite($36);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(ord(datbyte));             (* Datenbyte senden *)
  err1 := err;
end;

(* Status der Druckerschnittstelle lesen *)

procedure mlprnstat(var err1,status : byte);
var
   cmd : byte;

begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  status := 0;                       (* Default = 0 setzen *)
  mlwrite($3C);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlread(cmd);                       (* Datenbyte lesen *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  if cmd = $3C then                  (* Datenbyte = Befehlscode -> *)
    mlread(status)                   (* Status lesen *)
  else
    err1 := cmd;                     (* sonst : Fehler *)
end;

(* Status des Druckerbuffers lesen *)

procedure mlprnbufstat(var err1 : byte;var status : byte);
var
   cmd : byte;

begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  status := 0;                       (* Default = 0 setzen *)
  mlwrite($3D);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlread(cmd);                       (* Datenbyte lesen *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  if cmd = $3D then                  (* Datenbyte = Befehlscode -> *)
    mlread(status)                   (* Status lesen *)
  else
    err1 := cmd;
end;

(* Byte an Drucker ueber Buffer ausgeben *)

procedure mlprnbufwrite(var err1 : byte;datbyte : char);
begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  mlwrite($37);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(ord(datbyte));             (* Datenbyte senden *)
  err1 := err;
end;

(* Groesse des Druckerbuffers lesen *)

procedure mlgetbuf(var err1 : byte;var status : byte);
var
   cmd : byte;

begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  status := 0;                       (* Default = 0 setzen *)
  mlwrite($3E);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlread(cmd);                       (* Datenbyte lesen *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  if cmd = $3E then                  (* Datenbyte = Befehlscode -> *)
    mlread(status)                   (* Status lesen *)
  else
    err1 := cmd;
end;

(* Buffergroesse definieren *)

procedure mlsetbuf(var err1 : byte;datbyte : byte);
begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  mlwrite($38);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(datbyte);                  (* Datenbyte senden *)
  err1 := err;
end;

(* Ausgabe aus Buffer an Drucker unterbrechen *)

procedure mlprnbufstop(var err1 : byte);
begin
  mlwrite($3A);                      (* Befehlscode senden *)
  err1 := err;
end;

(* Ausgabe aus Buffer an Drucker fortsetzen *)

procedure mlprnbufstart(var err1 : byte);
begin
  mlwrite($3B);                      (* Befehlscode senden *)
  err1 := err;
end;

(********************** Serielle Schnittstelle *******************************)

(* Serielle Schnittstelle initialisieren *)

procedure mlserialinit(var err1 : byte;Usart,baud,dum1,dum2 : byte);
begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  mlwrite($40);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(usart);                    (* Datenbyte senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(baud);                     (* Datenbyte senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(dum1);
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(dum2);
  err1 := err;
end;

(* Byte an Serielle Schnittstelle ausgeben *)

procedure mlserialwr(var err1 : byte;datbyte : byte);
begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  mlwrite($42);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(datbyte);                  (* Datenbyte senden *)
  err1 := err;
end;

(* Byte von Serieller Schnittstelle lesen *)

procedure mlserialre(var err1,datbyte : byte);
var
   cmd : byte;

begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  datbyte := 0;                      (* Default = 0 setzen *)
  mlwrite($44);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlread(cmd);                       (* Datenbyte lesen *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  if cmd = $44 then                  (* Datenbyte = Befehlscode -> *)
    mlread(datbyte)                  (* Datenbyte lesen *)
  else
    err1 := cmd;                     (* sonst : Fehler *)
end;

(* Receiver-Status von Serieller Schnittstelle lesen *)

procedure mlserialrst(var err1,status : byte);
var
   cmd : byte;

begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  status := 0;                       (* Default = 0 setzen *)
  mlwrite($45);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlread(cmd);                       (* Datenbyte lesen *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  if cmd = $45 then                  (* Datenbyte = Befehlscode -> *)
    mlread(status)                   (* Status lesen *)
  else
    err1 := cmd;                     (* sonst : Fehler *)
end;

(* Transmitter-Status von Serieller Schnittstelle lesen *)

procedure mlserialtst(var err1,status : byte);
var
   cmd : byte;

begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  status := 0;                       (* Default = 0 setzen *)
  mlwrite($46);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlread(cmd);                       (* Datenbyte lesen *)
  if cmd = $46 then                  (* Datenbyte = Befehlscode  -> *)
    mlread(cmd)                      (* Status lesen *)
  else
    err1 := cmd;                     (* sonst : Fehler *)
end;

(* Setze Sio-Flag *)

procedure mlserflagon(var err1 : byte);
begin
  mlwrite($48);                      (* Befehlcode senden *)
  err1 := err;
end;

(* Loesche Sio-Flag *)

procedure mlserflagoff(var err1 : byte);
begin
  mlwrite($49);                      (* Befehlcode senden *)
  err1 := err;
end;

(************************* Digitale Eingnge ********************************)

(* Zustand aller digitalen Eingaenge lesen *)

procedure mldiginall(var err1,ip07,ip815,ip1623 : byte);
var
   cmd : byte;

begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  ip07 := 0;ip815 := 0;ip1623 := 0;  (* Default = 0 setzen *)
  mlwrite($50);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlread(cmd);                       (* Datenbyte lesen *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  if cmd = $50 then                  (* Datenbyte = Befehlscode -> *)
    begin
      mlread(ip07);                  (* Zustaende lesen *)
      if err <> 0 then exit;         (* Globale Fehlervariable <> 0 ? *)
      mlread(ip815);
      if err <> 0 then exit;         (* Globale Fehlervariable <> 0 ? *)
      mlread(ip1623);
    end
  else
    err1 := cmd;
end;

(* Zustand der digitalen Eingaenge IP0 - IP7 lesen *)

procedure mldigin1(var err1,ip07 : byte);
var
   cmd : byte;

begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  ip07 := 0;                         (* Default = 0 setzen *)
  mlwrite($51);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlread(cmd);                       (* Datenbyte lesen *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  if cmd = $51 then                  (* Datenbyte = Befehlscode -> *)
    mlread(ip07)                     (* Datenbyte lesen *)
  else
    err1 := cmd;                     (* sonst : Fehler *)
end;

(* Zustand der digitalen Eingaenge IP8 - IP15 lesen *)

procedure mldigin2(var err1,ip815 : byte);
var
   cmd : byte;

begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  ip815 := 0;                        (* Default = 0 setzen *)
  mlwrite($52);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlread(cmd);                       (* Datenbyte lesen *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  if cmd = $52 then                  (* Datenbyte = Befehlscode -> *)
    mlread(ip815)                    (* Datenbyte lesen *)
  else
    err1 := cmd;                     (* sonst : Fehler *)
end;

(* Zustand der digitalen Eingaenge IP16 - IP23 lesen *)

procedure mldigin3(var err1,ip1623 : byte);
var
   cmd : byte;

begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  ip1623 := 0;                       (* Default = 0 setzen *)
  mlwrite($53);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlread(cmd);                       (* Datenbyte lesen *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  if cmd = $53 then                  (* Datenbyte = Befehlsbyte -> *)
    mlread(ip1623)                   (* Datenbyte lesen *)
  else
    err1 := cmd;                     (* sonst Fehler *)
end;

(* Zustand eines digitalen Eingangs lesen *)

procedure mldigbitin(var err1,zustand : byte;bit : byte);
var
   cmd : byte;

begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  zustand := 0;                      (* Default = 0 setzen *)
  mlwrite($54);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(bit mod 24);               (* Datenbyte senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlread(cmd);                       (* Datenbyte lesen *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  if cmd = $54 then                  (* Datenbyte = Befehlscode -> *)
    mlread(zustand)                  (* Datenbyte lesen *)
  else
    err1 := cmd;                     (* sonst : Fehler *)
end;

(************************** Digitale Ausgnge *******************************)

(* Alle digitalen Ausgaenge gleich 0 setzen *)

procedure mldigoutall0(var err1 : byte);
begin
  mlwrite($58);                      (* Befehlscode senden *)
  err1 := err;
end;

(* Alle digitalen Ausgaenge gleich 1 setzen *)

procedure mldigoutall1(var err1 : byte);
begin
  mlwrite($59);                      (* Befehlscode senden *)
  err1 := err;
end;

(* Alle digitalen Ausgaenge setzen *)

procedure mldigoutall(var err1 : byte;op07,op815,op1623 : byte);
begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  mlwrite($5A);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(op07);                     (* Datenbyte senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(op815);                    (* Datenbyte senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(op1623);                   (* Datenbyte senden *)
  err1 := err;
end;

(* Die digitalen Ausgaenge OP0 - OP7 setzen *)

procedure mldigout1(var err1 : byte;op07 : byte);
begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  mlwrite($5B);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(op07);                     (* Datenbyte senden *)
  err1 := err;
end;

(* Die digitalen Ausgaenge OP8 - OP15 setzen *)

procedure mldigout2(var err1 : byte;op815 : byte);
begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  mlwrite($5C);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(op815);                    (* Datenbyte senden *)
  err1 := err;
end;

(* Die digitalen Ausgaenge OP16 - OP23 setzen *)

procedure mldigout3(var err1 : byte;op1623 : byte);
begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  mlwrite($5D);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(op1623);                   (* Datenbyte senden *)
  err1 := err;
end;

(* Einen digitalen Ausgang gleich 0 setzen *)

procedure mldigbitout0(var err1 : byte;bit : byte);
begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  mlwrite($5E);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(bit mod 24);               (* Datenbyte senden *)
  err1 := err;
end;

(* Einen digitalen Ausgang gleich 1 setzen *)

procedure mldigbitout1(var err1 : byte;bit : byte);
begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  mlwrite($5F);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(bit mod 24);               (* Datenbyte senden *)
  err1 := err;
end;

(************************** 12 Bit D/A Wandler *******************************)

(* 12-Bit Wert an D/A-Kanal ausgeben *)

procedure mlda12out(var err1 : byte;kanal : byte;datbyte : integer);
begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  if kanal = 1 then                  (* D/A-Kanal = 1 -> *)
    mlwrite($60)                     (* Befehlscode senden *)
  else
    if kanal = 2 then                (* oder D/A-Kanal = 2 -> *)
      mlwrite($61);                  (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  if kanal in [1..2] then            (* D/A-Kanal = 1 oder 2 -> *)
    begin
      mlwrite(lo(datbyte));          (* Datenbyte (Low-Byte) senden *)
      if err <> 0 then exit;         (* Globale Fehlervariable <> 0 ? *)
      mlwrite(hi(datbyte));          (* Datenbyte (High-Byte) senden *)
      err1 := err;
    end
  else
    err1 := 1;                       (* sonst : Fehler *)
end;

(* Alle D/A-Wandler mit Aussteuerbereich 0 - 5 Volt *)

procedure mlda812out(var err1 : byte;kanal : byte;datbyte : integer);
begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  mlwrite($69);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(kanal);                    (* Kanalnummer senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(lo(datbyte));              (* Datenbyte (Low-Byte) senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(hi(datbyte));              (* Datenbyte (High-Byte) senden *)
  err1 := err;
end;

(* Abgleich der D/A-Wandler *)

procedure mldaabgleich(var err1 : byte);
begin
  mlwrite($6B);                      (* Befehlscode senden *)
  err1 := err;
end;

(* Beim Abgleich ermittelte Korrekturwerte ignorieren *)

procedure mldaignabgl(var err1 : byte);
begin
  mlwrite($6C);                      (* Befehlscode senden *)
  err1 := err;
end;

(* Pen up *)

procedure mlpenup(var err1 : byte);
begin
  mlwrite($63);                      (* Befehlscode senden *)
  err1 := err;
end;

(* Pen down *)

procedure mlpendown(var err1 : byte);
begin
  mlwrite($64);                      (* Befehlscode senden *)
  err1 := err;
end;

(* Status von Pen *)

procedure mlpenstat(var err1,zustand : byte);
var
   cmd : byte;

begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  zustand := 0;                      (* Default = 0 setzen *)
  mlwrite($6E);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlread(cmd);                       (* Datenbyte lesen *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  if cmd = $6E then                  (* Datenbyte = Befehlscode -> *)
    mlread(zustand)                  (* Status lesen *)
  else
    err1 := cmd;
end;

(* 12-Bit Wert an D/A-Kanal ausgeben (2er Komplement) *)

procedure mlda122er(var err1 : byte;kanal : byte;datbyte : integer);
begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  if kanal = 1 then                  (* D/A-Kanal = 1 -> *)
    mlwrite($7A)                     (* Befehlscode senden *)
  else
    if kanal = 2 then                (* oder D/A-Kanal = 2 -> *)
      mlwrite($7B);                  (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  if kanal in [1..2] then            (* D/A-Kanal = 1 oder 2 -> *)
    begin
      mlwrite(lo(datbyte));          (* Datenbyte (Low-Byte) senden *)
      if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
      mlwrite(hi(datbyte));          (* Datenbyte (High-Byte) senden *)
      err1 := err;
    end
  else
    err1 := 1;                        (* sonst : Fehler *)
end;

(* DA-X und DA-Y als Plotter : Positioniere auf X0/Y0 *)

procedure mlposxy(var err1 : byte;X0,Y0 : integer);
begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  mlwrite($65);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(lo(X0));                   (* X0 (Low-Byte) senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(hi(X0));                   (* X0 (High-Byte) senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(lo(Y0));                   (* Y0 (Low-Byte) senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(hi(Y0));                   (* Y0 (High-Byte) senden *)
  err1 := err;
end;

(* DA-X und DA-Y als Plotter : Linie ziehen von X0/Y0 nach X1/Y1 *)

procedure mllinxy(var err1 : byte;X1,Y1 : integer);
begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  mlwrite($66);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(lo(X1));                   (* X1 (Low-Byte) senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(hi(X1));                   (* X1 (High-Byte) senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(lo(Y1));                   (* Y1 (Low-Byte) senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(hi(Y1));                   (* Y1 (High-Byte) senden *)
  err1 := err;
end;

(* Korrekturflag setzen *)

procedure mlsetkorflag(var err1 : byte;flag : byte);
begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  mlwrite($7C);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(flag);                     (* Datenbyte senden *)
  err1 := err;
end;

(* Korrekturwerte setzen *)

procedure mlsetkorwert(var err1 : byte;flag : byte;wert : integer);
begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  mlwrite($7D);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(flag);                     (* Datenbyte senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(lo(wert));                 (* Datenwert (Low-Byte) senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(hi(wert));                 (* Datenwert (High-Byte) senden *)
  err1 := err;
end;

(**************************** 8 Bit D/A-Wandler ******************************)

(* 8-Bit Wert an D/A-Kanal ausgeben *)

procedure mlda8out(var err1 : byte;kanal,datbyte : byte);
begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  mlwrite($70+(kanal mod 16));       (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(datbyte);                  (* Datenbyte senden *)
  err1 := err;
end;

(******************************* A/D-Wandler ********************************)

(* 12-Bit Wert von A/D-Kanal lesen *)

procedure mlad12in(var err1 : byte;var datbyte : integer;kanal : byte);
var
   dat1,dat2 : byte;

begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  datbyte := 0;                      (* Default = 0 setzen *)
  mlwrite($80+(kanal mod 16));       (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlread(dat1);                      (* Datenbyte lesen *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  if dat1 = ($80+(kanal mod 16)) then  (* Datenbyte = Befehlscode -> *)
    begin
      mlread(dat1);                  (* Datenbyte (Low-Byte) lesen *)
      if err <> 0 then exit;         (* Globale Fehlervariable <> 0 ? *)
      mlread(dat2);                  (* Datenbyte (High-Byte) lesen *)
      datbyte := dat2;
      datbyte := datbyte * 256 + dat1;
      err1 := err;
    end
  else
    err1 := dat1;                    (* sonst : Fehler *)
end;

(* 8-Bit Wert von A/D-Kanal lesen *)

procedure mlad8in(var err1,datbyte : byte;kanal : byte);
var
   cmd : byte;

begin
  err1 := 0;                          (* Errorvariable default = 0 setzen *)
  datbyte := 0;                       (* Default = 0 setzen *)
  mlwrite($90+(kanal mod 16));        (* Befehlscode senden *)
  if err <> 0 then exit;              (* Globale Fehlervariable <> 0 ? *)
  mlread(cmd);                        (* Datenbyte lesen *)
  if err <> 0 then exit;              (* Globale Fehlervariable <> 0 ? *)

  if cmd = ($90+(kanal mod 16)) then  (* Datenbyte = Befehlscode -> *)

    mlread(datbyte)                   (* Datenbyte lesen *)
  else
    err1 := cmd;                      (* sonst : Fehler *)
end;

(* 12 Bit-Wert von A/D-Kanal lesen und im 2er Komplement ausgeben *)

procedure mlad122er(var err1 : byte;var datbyte : integer;var kanal : byte);
var
   dat1,dat2 : byte;

begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  datbyte := 0;                      (* Default = 0 setzen *)
  mlwrite($78);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(kanal);                    (* Kanalnummer senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlread(dat1);                      (* Datenbyte lesen *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  if dat1 = $78 then                 (* Datenbyte = Befehlscode -> *)
    begin
      mlread(kanal);                 (* Kanal lesen *)
      if err <> 0 then exit;         (* Globale Fehlervariable <> 0 ? *)
      mlread(dat1);                  (* Datenbyte (Low-Byte) lesen *)
      if err <> 0 then exit;         (* Globale Fehlervariable <> 0 ? *)
      mlread(dat2);                  (* Datenbyte (High-Byte) lesen *)
       datbyte := dat2;
      datbyte := datbyte * 256 + dat1;
      err1 := err;
    end
  else
    err1 := dat1;                    (* sonst : Fehler *)
end;

(* 12-Bit Wert von A/D-Kanal lesen *)

procedure mladsh12(var err1 : byte;var datbyte : wert;kanal : byte;anz : byte);
var
   dat1,dat2 : byte;
   i : byte;

begin
  err1 := 0;                           (* Errorvariable default = 0 setzen *)
  for i:= 1 to anz do datbyte[i] := 0;  (* Default = 0 setzen *)
  mlwrite($79);                        (* Befehlscode senden *)
  if err <> 0 then exit;               (* Globale Fehlervariable <> 0 ? *)
  mlwrite(kanal);                      (* Kanalnummer senden *)
  if err <> 0 then exit;               (* Globale Fehlervariable <> 0 ? *)
  mlwrite(anz);                        (* Anzahl der Kanaele senden *)
  if err <> 0 then exit;               (* Globale Fehlervariable <> 0 ? *)
  mlread(dat1);                        (* Datenbyte lesen *)
  if err <> 0 then exit;               (* Globale Fehlervariable <> 0 ? *)
  if dat1 = $79 then                   (* Datenbyte = Befehlscode -> *)
    begin
      i := 0;
      repeat
        i := i + 1;
        mlread(dat1);                  (* Datenbyte (Low-Byte) lesen *)
        if err <> 0 then exit;         (* Globale Fehlervariable <> 0 ? *)
        mlread(dat2);                  (* Datenbyte (High-Byte) lesen *)
        datbyte[i] := dat2;
        datbyte[i] := datbyte[i] * 256 + dat1;
      until (i = anz) or (err <> 0);
      err1 := err;
    end
  else
    err1 := dat1;                      (* sonst : Fehler *)
end;

(* 12 Bit-Wert von A/D-Kanal lesen (20 mA Schnittstelle *)

procedure mlad1220(var err1 : byte;var datbyte : integer;var kanal : byte);
var
   dat1,dat2 : byte;

begin
  err1 := 0;                           (* Errorvariable default = 0 setzen *)
  datbyte := 0;                        (* Default = 0 setzen *)
  mlwrite($7E);                        (* Befehlscode senden *)
  if err <> 0 then exit;               (* Globale Fehlervariable <> 0 ? *)
  mlwrite(kanal);                      (* Kanalnummer senden *)
  if err <> 0 then exit;               (* Globale Fehlervariable <> 0 ? *)
  mlread(dat1);                        (* Datenbyte lesen *)
  if err <> 0 then exit;               (* Globale Fehlervariable <> 0 ? *)
  if dat1 = $7E then                   (* Datenbyte = Befehlscode -> *)
    begin
      mlread(dat1);                    (* Datenbyte (Low-Byte) lesen *)
      if err <> 0 then exit;           (* Globale Fehlervariable <> 0 ? *)
      mlread(dat2);                    (* Datenbyte (High-Byte) lesen *)
      datbyte := dat2;
      datbyte := datbyte * 256 + dat1;
      err1 := err;
    end
  else
    err1 := dat1;                      (* sonst : Fehler *)
end;

(* 12 Bit-Wert von A/D-Kanal lesen (mit Subaveraging) *)

procedure mlad12sa(var err1 : byte;var datbyte : integer;kanal,anz : byte);
var
   dat1,dat2 : byte;

begin
  err1 := 0;                           (* Errorvariable default = 0 setzen *)
  datbyte := 0;                        (* Default = 0 setzen *)
  mlwrite($7F);                        (* Befehlscode senden *)
  if err <> 0 then exit;               (* Globale Fehlervariable <> 0 ? *)
  mlwrite(kanal);                      (* Kanalnummer senden *)
  if err <> 0 then exit;               (* Globale Fehlervariable <> 0 ? *)
  mlwrite(anz);                        (* Anzahl der Mittelungen *)
  if err <> 0 then exit;               (* Globale Fehlervariable <> 0 ? *)
  mlread(dat1);                        (* Datenbyte lesen *)
  if err <> 0 then exit;               (* Globale Fehlervariable <> 0 ? *)
  if dat1 = $7F then                   (* Datenbyte = Befehlscode -> *)
    begin
      mlread(dat1);                    (* Datenbyte (Low-Byte) lesen *)
      if err <> 0 then exit;           (* Globale Fehlervariable <> 0 ? *)
      mlread(dat2);                    (* Datenbyte (High-Byte) lesen *)
      datbyte := dat2;
      datbyte := datbyte * 256 + dat1;
      err1 := err;
    end
  else
    err1 := dat1;                     (* sonst : Fehler *)
end;

(********************************** Uhr **************************************)

(* Betriebsart Uhr setzen *)

procedure mlbartuhr(var err1 : byte;art : byte);
begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  mlwrite($E0);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(art);                      (* Datenbyte senden *)
  err1 := err;
  delay(20);
end;

(* Status festlegen *)

procedure mlsetbart(var err1 : byte;maske,wert : byte);
begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  mlwrite($E8);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(maske);                    (* Maske senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(wert);                     (* Bits senden *)
  err1 := err;
  delay(20);
end;

(* Uhrzeit setzen *)

procedure mlsetuhrzeit(var err1 : byte;sec,min,std : byte);
begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  mlwrite($E1);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(sec);                      (* Datenbyte senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(min);                      (* Datenbyte senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(std);                      (* Datenbyte senden *)
  err1 := err;
  delay(20);
end;

(* Datum setzen *)

procedure mlsetuhrdatum(var err1 : byte;tag,mon,jahr,wochentag,woche : byte);
begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  mlwrite($EC);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(tag);                      (* Datenbyte senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(mon);                      (* Datenbyte senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(jahr);                     (* Datenbyte senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(wochentag);                (* Datenbyte senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(woche);                    (* Datenbyte senden *)
  err1 := err;
  delay(20);
end;

(* Alarmzeitgeber setzen *)

procedure mlsetal(var err1 : byte;sec,min,std,tag : byte);
begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  mlwrite($E2);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(sec);                      (* Datenbyte senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(min);                      (* Datenbyte senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(std);                      (* Datenbyte senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(tag);                      (* Datenbyte senden *)
  err1 := err;
  delay(20);
end;

(* Timer T setzen *)

procedure mlsettim(var err1 : byte;sec,min,std : byte);
begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  mlwrite($E3);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(sec);                      (* Datenbyte senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(min);                      (* Datenbyte senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(std);                      (* Datenbyte senden *)
  err1 := err;
  delay(20);
end;

(* Uhrzeit lesen *)

procedure mlgetuhrzeit(var err1,sec,min,std : byte);
var
   cmd : byte;

begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  sec := 0;min := 0;std := 0;        (* Default = 0 setzen *)
  mlwrite($E5);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  delay(20);
  mlread(cmd);                       (* Datenbyte lesen *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  if cmd = $E5 then                  (* Datenbyte = Befehlscode -> *)
    begin
      mlread(sec);                   (* Datenbyte lesen *)
      if err <> 0 then exit;         (* Globale Fehlervariable <> 0 ? *)
      mlread(min);                   (* Datenbyte lesen *)
      if err <> 0 then exit;         (* Globale Fehlervariable <> 0 ? *)
      mlread(std);                   (* Datenbyte lesen *)
    end
  else
    err1 := cmd;
end;

(* Datum lesen *)

procedure mlgetuhrdatum(var err1,tag,mon,jahr,wochentag,woche : byte);
var
   cmd : byte;

begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  tag := 0;mon := 0;jahr := 0;
  wochentag := 0;woche := 0;         (* Default = 0 setzen *)
  mlwrite($ED);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  delay(20);
  mlread(cmd);                       (* Datenbyte lesen *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  if cmd = $ED then                  (* Datenbyte = Befehlscode -> *)
    begin
      mlread(tag);                   (* Datenbyte lesen *)
      if err <> 0 then exit;         (* Globale Fehlervariable <> 0 ? *)
      mlread(mon);                   (* Datenbyte lesen *)
      if err <> 0 then exit;         (* Globale Fehlervariable <> 0 ? *)
      mlread(jahr);                  (* Datenbyte lesen *)
      if err <> 0 then exit;         (* Globale Fehlervariable <> 0 ? *)
      mlread(wochentag);             (* Datenbyte lesen *)
      if err <> 0 then exit;         (* Globale Fehlervariable <> 0 ? *)
      mlread(woche);                 (* Datenbyte lesen *)
    end
  else
    err1 := cmd;
end;

(* Alarmzeitgeber lesen *)

procedure mlgetal(var err1,sec,min,std,tag : byte);
var
   cmd : byte;

begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  sec := 0;min := 0;std := 0;tag := 0; (* Default = 0 setzen *)
  mlwrite($E6);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  delay(20);
  mlread(cmd);                       (* Datenbyte lesen *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  if err1 = $E6 then                 (* Datenbyte = Befehlscode -> *)
    begin
      mlread(sec);                   (* Datenbyte lesen *)
      if err <> 0 then exit;         (* Globale Fehlervariable <> 0 ? *)
      mlread(min);                   (* Datenbyte lesen *)
      if err <> 0 then exit;         (* Globale Fehlervariable <> 0 ? *)
      mlread(std);                   (* Datenbyte lesen *)
      if err <> 0 then exit;         (* Globale Fehlervariable <> 0 ? *)
      mlread(tag);                   (* Datenbyte lesen *)
      err1 := err;
    end;
end;

(* Timer T lesen *)

procedure mlgettim(var err1,sec,min,std : byte);
var
   cmd : byte;

begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  sec := 0;min := 0;std := 0;        (* Default = 0 setzen *)
  mlwrite($E7);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  delay(20);
  mlread(cmd);                       (* Datenbyte lesen *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  if cmd = $E7 then                  (* Datenbyte = Befehlscode -> *)
    begin
      mlread(sec);                   (* Datenbyte lesen *)
      if err <> 0 then exit;         (* Globale Fehlervariable <> 0 ? *)
      mlread(min);                   (* Datenbyte lesen *)
      if err <> 0 then exit;         (* Globale Fehlervariable <> 0 ? *)
      mlread(std);                   (* Datenbyte lesen *)
    end
  else
    err1 := cmd;
end;

(* Betriebsart der Uhr lesen *)

procedure mlgetbart(var err1,zustand : byte);
var
   cmd : byte;

begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  zustand := 0;                      (* Default = 0 setzen *)
  mlwrite($E4);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  delay(20);
  mlread(cmd);                       (* Datenbyte lesen *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  if cmd = $E4 then                  (* Datenbyte = Befehlscode -> *)
    mlread(zustand)                  (* Datenbyte lesen *)
  else
    err1 := cmd;                     (* sonst : Fehler *)
end;

(* Byte in nichtfluechtigen Speicher schreiben *)

procedure mlsetsp(var err1 : byte;speicher,data : byte);
begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  mlwrite($EE);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(speicher mod 15);          (* Datenbyte senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(data);                     (* Datenbyte senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  err1 := err;
  delay(20);
end;

(* Byte aus nichtfluechtigen Speicher lesen *)

procedure mlgetsp(var err1,datbyte : byte;speicher : byte);
var
   cmd : byte;

begin
  err1 := 0;                         (* Errorvariable default = 0 setzen *)
  datbyte := 0;                      (* Default = 0 setzen *)
  mlwrite($EF);                      (* Befehlscode senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  mlwrite(speicher mod 15);          (* Datenbyte senden *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  delay(20);
  mlread(cmd);                       (* Datenbyte lesen *)
  if err <> 0 then exit;             (* Globale Fehlervariable <> 0 ? *)
  if cmd = $EF then                  (* Datenbyte = Befehlscode -> *)
    mlread(datbyte)                  (* Datenbyte lesen *)
  else
    err1 := cmd;                     (* sonst : Fehler *)
end;

end.                      (* Turbo-PASCAL 4.0, 5.0, 5.5 spezifisch *)
